​http://www.elijahqi.win/archives/1002​​​
题目描述

Due to a lack of rain, Farmer John wants to build an irrigation system to

send water between his N fields (1 <= N <= 2000).

Each field i is described by a distinct point (xi, yi) in the 2D plane,

with 0 <= xi, yi <= 1000. The cost of building a water pipe between two

fields i and j is equal to the squared Euclidean distance between them:

(xi - xj)^2 + (yi - yj)^2

FJ would like to build a minimum-cost system of pipes so that all of his

fields are linked together – so that water in any field can follow a

sequence of pipes to reach any other field.

Unfortunately, the contractor who is helping FJ install his irrigation

system refuses to install any pipe unless its cost (squared Euclidean

length) is at least C (1 <= C <= 1,000,000).

Please help FJ compute the minimum amount he will need pay to connect all

his fields with a network of pipes.

农民约翰想建立一个灌溉系统,给他的N(1 <= N <= 2000)块田送水。农田在一个二维平面上,第i块农田坐标为(xi, yi)(0 <= xi, yi <= 1000),在农田i和农田j自己铺设水管的费用是这两块农田的欧几里得距离(xi - xj)^2 + (yi - yj)^2。

农民约翰希望所有的农田之间都能通水,而且希望花费最少的钱。但是安装工人拒绝安装费用小于C的水管(1 <= C <= 1,000,000)。

请帮助农民约翰建立一个花费最小的灌溉网络。

输入输出格式

输入格式:

Line 1: The integers N and C.
Lines 2..1+N: Line i+1 contains the integers xi and yi.
输出格式:

Line 1: The minimum cost of a network of pipes connecting the
fields, or -1 if no such network can be built.

输入输出样例

输入样例#1:

3 11
0 2
5 0
4 3
输出样例#1:

46
说明

INPUT DETAILS:

There are 3 fields, at locations (0,2), (5,0), and (4,3). The contractor

will only install pipes of cost at least 11.

OUTPUT DETAILS:

FJ cannot build a pipe between the fields at (4,3) and (5,0), since its

cost would be only 10. He therefore builds a pipe between (0,2) and (5,0)

at cost 29, and a pipe between (0,2) and (4,3) at cost 17.

Source: USACO 2014 March Contest, Silver

求一个欧几里得距离 预处理一下即可

学习了一下prim 记录一下

Prim& kruscal都是利用了贪心的思想 kruscal利用的是 求出所有边的权值 然后针对权值进行排序,贪心的每次选择最小的 然后 是把两端的点加入并查集,下次再寻找最小,如果不在同一集合就加入,可以生成最小的生成树

Prim: 首先我钦定一个点,一号点作为我开始的点,然后我把一号点连接的边都更新一下,观察到我其他点 的一次权值是否能更新若可以更新,则放入队列,以便后面使用 每次访问一个点的时候都把从前一层到这里的权值加上

作为到这个点的最小生成树的边,统计答案

#include<cstdio>
#include<queue>
#include<vector>
#include<cstring>
#define N 2200
#define pa pair<int,int>
using namespace std;
priority_queue<pa,vector<pa>,greater<pa> >q;
inline int read(){
int x=0;char ch=getchar();
while (ch<'0'||ch>'9') ch=getchar();
while (ch<='9'&&ch>='0'){x=x*10+ch-'0';ch=getchar();}
return x;
}
struct node{
int y,next,z;
}data[2*N*N];
inline int gc(int x){return x*x;}
inline bool cmp(node a,node b){return a.z<b.z;}
int h[N],x[N],y[N],ans,cnt,n,c,num,f[N];bool visit[N];
void prim(){
q.push(make_pair(0,1));memset(f,0x7f,sizeof(f));f[1]=0;
while (!q.empty()){
int x=q.top().second;q.pop();if (visit[x]) continue;++cnt;ans+=f[x];visit[x]=true;
for (int i=h[x];i;i=data[i].next){
int y=data[i].y,z=data[i].z;
if (visit[y]) continue;
if (z<=f[y]) f[y]=z,q.push(make_pair(z,y));
}
}
}
int main(){
freopen("2212.in","r",stdin);
n=read();c=read();
for (int i=1;i<=n;++i) x[i]=read(),y[i]=read();
for (int i=1;i<=n;++i)
for (int j=i+1;j<=n;++j){
if (gc(x[i]-x[j])+gc(y[i]-y[j])>=c){
data[++num].y=j;data[num].next=h[i];data[num].z=gc(x[i]-x[j])+gc(y[i]-y[j]);h[i]=num;
data[++num].y=i;data[num].next=h[j];data[num].z=gc(x[i]-x[j])+gc(y[i]-y[j]);h[j]=num;
}
}
prim();
if (cnt!=n) printf("-1");else printf("%d",ans);
return 0;
}